﻿using System.Windows;
using System.Windows.Media;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;

namespace StraightVideo
{
    public partial class MainPage : PhoneApplicationPage
    {
        CaptureSource captureSource;

        public MainPage()
        {
            InitializeComponent();

            captureSource = new CaptureSource
            {
                VideoCaptureDevice = CaptureDeviceConfiguration.GetDefaultVideoCaptureDevice()
            };
        }

        protected override void OnNavigatedTo(NavigationEventArgs args)
        {
            if (captureSource != null && CaptureDeviceConfiguration.AllowedDeviceAccess)
            {
                videoBrush.SetSource(captureSource);
                captureSource.Start();
                startButton.Visibility = Visibility.Collapsed;
            }
            base.OnNavigatedTo(args);
        }

        protected override void OnNavigatedFrom(NavigationEventArgs args)
        {
            if (captureSource != null && captureSource.State == CaptureState.Started)
            {
                captureSource.Stop();
                startButton.Visibility = Visibility.Visible;
            }
            base.OnNavigatedFrom(args);
        }

        void OnStartButtonClick(object sender, RoutedEventArgs args)
        {
            if (captureSource != null && 
                (CaptureDeviceConfiguration.AllowedDeviceAccess ||
                 CaptureDeviceConfiguration.RequestDeviceAccess()))
            {
                videoBrush.SetSource(captureSource);
                captureSource.Start();
                startButton.Visibility = Visibility.Collapsed;
            }
        }
    }
}